import parser
import knowledgebase
import semanticnetwork

def get_line(s):
    statement = raw_input("%s>>> " % s)
    return statement.split(" ")

#recursive learner
def learn(kb, word):
    if not word in kb.language:
        if not word in kb.language:
            type_word = get_line("What is the part of speech of %s?" % word)[0]
            if not type_word == 'None':
                learn(kb, type_word)
                kb.language.link(word,type_word)
        if not word in kb.category:
            meaning_word = raw_input("Categorize the word "+word+"? >>>") 
            if not meaning_word == 'None':
                learn(kb, meaning_word)			
                kb.category.link(word,meaning_word)	
    else:
        return

def imperative():
    print "dog"

def np_declarative(kb, np):
    if not np or not np.adjs:
        return
    print np.noun
    n = np.get_subject()
    print "Handling n=%s" % n
    for adj in np.adjs:
        print adj
        # reject duplicates
        if kb['attributes'].contains_link(n, adj):
            print "I already know that %s is %s." % (n, adj)
            continue
        # check and add attributes
        adjcat = set(kb['category'][adj])
        disjoint = True
        for attr in kb['attributes'][n]:
            disjoint = disjoint and set(kb['category'][attr]).isdisjoint(adjcat)
        if disjoint:
            kb.attributes.link(n, adj)
        else:
            print "Contradiction!"
            
    # if the noun phrase contains a prepositional phrase, and that
    # preposition phrase contains a noun phrase, recursively descend
    if np.pp and np.pp.np:
        np_declarative(kb, np.pp.np)
    else:
        return

def declarative_meanings(kb, parsed_sentence):
    if not parsed_sentence.np:
        return
    #Noun, pronoun or proper_noun
    subject = parsed_sentence.np.get_subject()
    #Link subject to tuple of (verb, object)-- The cat is fat.
    verb = parsed_sentence.vp.verb
    if parsed_sentence.vp.adjs is not None:
        kb.get_base("attributes").link(subject, 
                                       (parsed_sentence.vp.adv + verb)
                                        if parsed_sentence.vp.adv 
                                        else (verb,parsed_sentence.vp.adjs))
        #if parsed_sentence.vp.adv is not None:
            ##How are we storing this
         #   print "??"
    #No object in this case
    #Or link subject to tuple (verb)-- The cat runs.
   
    else:
        kb.attributes.link(subject, 
                           parsed_sentence.vp.adv + verb
                           if parsed_sentence.vp.adv else verb)
        #print thing
        #print subject
        
        # Loop over all noun phrases check if that is stored If there
        # is a verb phrase, then relate the NP to it If there is NVN
        # then relate the noun to the other noun through the verb

				
        #elif parsed_sentence: #is a question

def declarative(kb, sentence):
    #Add all noun phrase adjectives to knowledge base
    if sentence.vp and len(sentence.vp.adjs) > 0:
        sentence.np.adjs.extend(sentence.vp.adjs)
    np_declarative(kb, sentence.np)
    #Add all verb phrase adjective derivatives to knowledge base
    if sentence.vp:
        np_declarative(kb, sentence.vp.np)
        np_declarative(kb, sentence.vp.pp)
    declarative_meanings(kb, sentence)
    print "done"
def question():
    print "ok"

def process_line(kb, words):
    """
    Read in and process one line of input. If the input is 'bye', halt.
    """
    # check if we should continue
    if words[0] == "bye":
        return (False, '')

    # assert that we know every word
    for word in parser.listify(kb.language, ' '.join(words)):
        learn(kb, word)
    
    try:
        parsed_sentence = parser.Sentence(' '.join(words), kb)
    except parser.ParseError as e:
        return (True, "Huh?")
        
    sentence_type = parsed_sentence.get_sentence_type()
    if sentence_type == parser.DECLARATIVE:
        declarative(kb, parsed_sentence)
    elif sentence_type == parser.QUESTION:
        pass
    elif sentence_type == parser.IMPERATIVE:
        pass
    return (True, '')

def main(kb_files):
    kb = knowledgebase.bootstrap(kb_files)
    kb.add_base('attributes')
    kb.add_base('category')
    
    cont = True
    while cont:
        (cont, out) = process_line(kb, get_line("Input>>> "))
        print out

