import sys
from os import path

# add modules to the import path
modules_path = path.dirname(path.abspath(__file__)) + path.sep + ".."
sys.path.append(modules_path)

from cmsc421p5.semanticnetwork import TangledSemanticNetwork
from cmsc421p5.knowledgebase import KnowledgeBase 
import unittest
import pytest


class TestKnowledgeBase(unittest.TestCase):
    
    def test_add_base(self):
        kb = KnowledgeBase(['foo'])
        self.assert_('foo' in kb._bases)
        self.assertEqual(type(kb._bases['foo']), TangledSemanticNetwork)
        kb.add_base('bar')
        self.assert_('bar' in kb._bases)
        self.assertEqual(type(kb._bases['bar']), TangledSemanticNetwork)

    def test_contains_base(self):
        kb = KnowledgeBase(['foo'])
        self.assert_('foo' in kb)
        self.assertFalse('bar' in kb)

    def test_get_base(self):
        kb = KnowledgeBase(['foo'])
        foo = kb.get_base('foo')
        self.assertEqual(type(foo), TangledSemanticNetwork)
        
    def test_del_base(self):
        kb = KnowledgeBase(['foo'])
        self.assert_('foo' in kb)
        kb.del_base('foo')
        self.assertFalse('foo' in kb)
        


if __name__ == "__main__":
    pytest.main()
